/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */

package com.sun.enterprise.management.monitor;

import com.sun.appserv.management.base.XTypes;
import com.sun.appserv.management.config.LoadBalancerConfig;
import java.util.Map;
import javax.management.j2ee.statistics.Statistic;

import com.sun.appserv.management.monitor.statistics.LoadBalancerContextRootStats;
import com.sun.appserv.management.util.misc.ExceptionUtil;
import com.sun.appserv.management.j2ee.statistics.StatsImpl;
import com.sun.appserv.management.monitor.LoadBalancerContextRootMonitor;

import com.sun.enterprise.management.monitor.stats.CustomMonitoringStatsImplBase;
import com.sun.enterprise.management.monitor.stats.LoadBalancerContextRootStatsImpl;
import com.sun.enterprise.management.monitor.stats.CustomMonitoringStatsImplBase;
import com.sun.enterprise.management.monitor.stats.CustomStatsImpl;
import com.sun.enterprise.management.monitor.stats.LoadBalancerContextRootStatsImpl;

public final class LoadBalancerContextRootMonitorImpl extends CustomMonitoringStatsImplBase {
    
    public LoadBalancerContextRootMonitorImpl() {
        super(LoadBalancerContextRootMonitor.J2EE_TYPE);
    }

    public final java.lang.Class getStatsInterface() {
        return LoadBalancerContextRootStats.class;
    }

    public LoadBalancerContextRootStats getLoadBalancerContextRootStats() {
        return (LoadBalancerContextRootStats) getStats();
    }
    
    protected StatsImpl createStatsImpl() {
        String contextRoot = getName();
        String lbName = getObjectName().getKeyProperty(XTypes.LOAD_BALANCER_MONITOR);
        String clusterName = getObjectName().getKeyProperty(XTypes.LOAD_BALANCER_CLUSTER_MONITOR);
        String instanceName = getObjectName().getKeyProperty(XTypes.LOAD_BALANCER_SERVER_MONITOR);
        String appName = getObjectName().getKeyProperty(XTypes.LOAD_BALANCER_APPLICATION_MONITOR);
        Map<String, LoadBalancerConfig> loadBalancerConfigMap =
            getDomainRoot().getDomainConfig().getLoadBalancerConfigMap();
        LoadBalancerConfig loadBalancerConfig = loadBalancerConfigMap.get(lbName);
        String lbConfigName = loadBalancerConfig.getLbConfigName();        
	LoadBalancerContextRootStatsImpl stats = 
                new LoadBalancerContextRootStatsImpl(lbName,lbConfigName,clusterName,
                                            instanceName,appName,contextRoot);
	return new StatsImpl(getStatisticsFromImpl(stats));
    }    
}